from PyHeap import PyHeap
from sys import stderr 

## Let's see how long it takes to lexically sort a bunch of numbers.
def mycmp(a, b):
    return cmp(tuple(str(a)), tuple(str(b)))

def test(mycmp):
    numbers = range(10000)
    heap = PyHeap(mycmp)
    print "Constructing heap"
    for n in numbers:
        heap.push(n)
    print "Construction done.  Now popping."

    sorted_numbers = []
    while heap.size() > 0:
        sorted_numbers.append(heap.pop())
    sorted_numbers.reverse()
    print "all popped.  Now testing against manual sort"
    numbers.sort(mycmp)

    for i in xrange(len(numbers)):
        assert numbers[i] == sorted_numbers[i], \
               ("Algorithmic problem at %d!" % i)
    print >>stderr, "Done!"


if __name__ == '__main__':
    while 1:
        print "Test with normal cmp"
        test(cmp)
        print
        print "Test with custom cmp"
        test(mycmp)  ## Stress test
        print
        
